library(Seurat)
library(ggplot2)
library(dplyr)
library(readr)
library('Matrix')

Spatialfile = "~/SpatialBenchmarking/SpatialLocationData/Dataset10/Spatial_count.txt"
Spatial_orig <- t(read.table(Spatialfile,sep = '\t',header = TRUE,quote = ""))
Genes = scan(Spatialfile,what = 'character',nlines=1)
rownames(Spatial_orig) = Genes
colnames(Spatial_orig) <- paste0("cell", 1:ncol(Spatial_orig))
Spatial = Spatial_orig
location = read.table("~/SpatialBenchmarking/SpatialLocationData/Dataset10/Locations.txt",header = TRUE)
rownames(location) = colnames(Spatial)
Spatial <- CreateSeuratObject(counts=Spatial, project='Spatial', min.cells=0, min.features=0)
DN<-30
anchors <- FindTransferAnchors(reference = Spatial,query = Spatial,features = rownames(Spatial),reduction = 'cca',reference.assay = 'RNA',query.assay = 'RNA', k.filter = NA, dims = 1:DN)
pseudo_loc <- TransferData(anchorset = anchors,refdata = t(location),query = Spatial,weight.reduction = 'pca',dims = 1:DN,slot = "data")

new_loc = as.data.frame(t(pseudo_loc@assays$id@data))
write.table(new_loc,file ="~/SpatialBenchmarking/SpatialLocationData/Dataset10/Seurat_pseudo_location.txt",sep='\t',quote=F,col.names = TRUE)
