## Dataset10

sce1 = readRDS("~/SpatialBenchmarking/SpatialLocationData/Dataset10/scDesign3_res.rds")
sce2 =  readRDS("~/SpatialBenchmarking/SpatialLocationData/Dataset10/scDesign3_perturb_res.rds")
sce_list = c(sce1[1:3],sce2)
aic = sapply(sce_list, function(x){
  x$model_aic[1]
})
bic = sapply(sce_list, function(x){
  x$model_bic[1]
})


cosine_similarity <- readRDS("~/SpatialBenchmarking/SpatialLocationData/Dataset10/cosine_similarity.rds")
cs1 <- apply(cosine_similarity, 2, function(x){mean(abs(x))})

cosine_similarity_perturb <- readRDS("~/SpatialBenchmarking/SpatialLocationData/Dataset10/cosine_similarity_perturb.rds")
cs2 <- apply(cosine_similarity_perturb, 2, function(x){mean(abs(x))})
cs = c(cs1,cs2)

metric= cbind(aic,bic,cs)
rownames(metric) = paste0("Dataset10_",names(cs))
colnames(metric) = c("AIC","BIC","Mean_Cosine_Similarity")

saveRDS(metric,"~/SpatialBenchmarking/SpatialLocationData/metric/Dataset10_metric.rds")



## Dataset4

sce1 = readRDS("~/SpatialBenchmarking/SpatialLocationData/Dataset4/scDesign3_res.rds")
sce2 =  readRDS("~/SpatialBenchmarking/SpatialLocationData/Dataset4/scDesign3_perturb_res.rds")
sce_list = c(sce1[1:3],sce2)
aic = sapply(sce_list, function(x){
  x$model_aic[1]
})
bic = sapply(sce_list, function(x){
  x$model_bic[1]
})


cosine_similarity <- readRDS("~/SpatialBenchmarking/SpatialLocationData/Dataset4/cosine_similarity.rds")
cs1 <- apply(cosine_similarity, 2, function(x){mean(abs(x))})

cosine_similarity_perturb <- readRDS("~/SpatialBenchmarking/SpatialLocationData/Dataset4/cosine_similarity_perturb.rds")
cs2 <- apply(cosine_similarity_perturb, 2, function(x){mean(abs(x))})
cs = c(cs1,cs2)

metric= cbind(aic,bic,cs)
rownames(metric) = paste0("Dataset4_",names(cs))
colnames(metric) = c("AIC","BIC","Mean_Cosine_Similarity")

saveRDS(metric,"~/SpatialBenchmarking/SpatialLocationData/metric/Dataset4_metric.rds")
