library(SingleCellExperiment)
library(tidyverse)

sce_name_list1 <- list.files("~/scDesign3/data/sce_hvg/", full.names = TRUE)
sce_name_list2 <- list.files("~/scDesign3/data/sce_hvg/", full.names = FALSE)

for (i in sce_name_list2) {
  sce <- readRDS(paste0("~/scDesign3/data/sce_hvg/", i))
  ncell <- dim(sce)[2]
  
  ntrain <- round(ncell/2)
  set.seed(123)
  train_index <- sample(seq_len(ncell), ntrain, replace = FALSE)
  
  train_sce <- sce[, train_index]
  test_sce <- sce[, -train_index]
  saveRDS(train_sce, paste0("~/scDesign3/data/sce_hvg_train/", i))
  saveRDS(test_sce, paste0("~/scDesign3/data/sce_hvg_test/", i))
  }