library(SingleCellExperiment)
library(tidyverse)
library(ggpubr)
library(cowplot)
library(ggrepel)
library(ggnewscale)
library(ggh4x)
library(mgcViz)
library(scDesign3)
theme_set(theme_bw())

PANCREAS_sce <- readRDS("~/scDesign3/data/sce_hvg_train/PANCREAS_sce.rds")

PANCREAS_data <- construct_data(
  sce = PANCREAS_sce[1:10, ],
  assay_use = "counts",
  celltype = "cell_type",
  pseudotime = "pseudotime",
  spatial = NULL,
  other_covariates = NULL,
  corr_by = "pseudotime"
)

PANCREAS_marginal <- fit_marginal(
  data = PANCREAS_data,
  predictor = "gene",
  mu_formula = "s(pseudotime, bs = 'cr', k = 10)",
  sigma_formula = "1",
  family_use = "nb",
  n_cores = 2,
  usebam = FALSE
)

saveRDS(PANCREAS_marginal, file = "~/scDesign3/figure/inference/PANCREAS_marginal.rds")