library(scDesign3)
library(scater)
library(scran)
library(tidyverse)

dataname <- "ACINAR"
train_sce <- readRDS(paste0("/home/dongyuan/scDesign3/data/sce_hvg_train/", dataname, "_sce.rds"))

train_sce <- train_sce[c("KLK4", "KLK2", "TMPRSS2"),]

### Start

## Vine
scDesign3Vine_result <- lapply(c(10, 20, 50, 100, 200, 400, 600), function(x) {
  x <- as.matrix(x)
  cat(x)
  cat("\n")
  start <- Sys.time()
  res <- scDesign3::scdesign3(sce = train_sce, 
                              assay_use = "counts", 
                              celltype = "cell_type", 
                              pseudotime = NULL, 
                              spatial = c("spatial1", "spatial2"), 
                              other_covariates = NULL, 
                              mu_formula = paste0("s(spatial1, spatial2, bs = 'gp', k = ", x , ")"), 
                              sigma_formula = "1", 
                              family_use = "nb", 
                              n_cores = 50, 
                              usebam = FALSE, 
                              corr_formula = "1", 
                              copula = "vine", 
                              DT = TRUE, 
                              pseudo_obs = FALSE, 
                              family_set = c("gauss", "indep"), 
                              nonnegative = TRUE, 
                              nonzerovar = TRUE, 
                              return_model = TRUE)
  
  end <- Sys.time()
  print(end - start)
  return(res)
})

saveRDS(scDesign3Vine_result, paste0("/home/dongyuan/scDesign3/data/cancer_comparison/", dataname, "_scDesign3Vine_result.rds"))



dataname <- "OVARIAN"
train_sce <- readRDS(paste0("/home/dongyuan/scDesign3/data/sce_hvg_train/", dataname, "_sce.rds"))

train_sce <- train_sce[c("PAX8", "AEBP1", "COL6A2"),]

### Start

## Vine
scDesign3Vine_result <- lapply(c(10, 20, 50, 100, 200, 400, 600), function(x) {
  x <- as.matrix(x)
  cat(x)
  cat("\n")
  start <- Sys.time()
  res <- scDesign3::scdesign3(sce = train_sce, 
                              assay_use = "counts", 
                              celltype = "cell_type", 
                              pseudotime = NULL, 
                              spatial = c("spatial1", "spatial2"), 
                              other_covariates = NULL, 
                              mu_formula = paste0("s(spatial1, spatial2, bs = 'gp', k = ", x , ")"), 
                              sigma_formula = "1", 
                              family_use = "nb", 
                              n_cores = 50, 
                              usebam = FALSE, 
                              corr_formula = "1", 
                              copula = "vine", 
                              DT = TRUE, 
                              pseudo_obs = FALSE, 
                              family_set = c("gauss", "indep"), 
                              nonnegative = TRUE, 
                              nonzerovar = TRUE, 
                              return_model = TRUE)
  
  end <- Sys.time()
  print(end - start)
  return(res)
})

saveRDS(scDesign3Vine_result, paste0("/home/dongyuan/scDesign3/data/cancer_comparison/", dataname, "_scDesign3Vine_result.rds"))
