ibrary(dyngen)
library(SingleCellExperiment)
set.seed(1)

#linear
backbone <- backbone_linear()
config <-
  initialise_model(
    backbone = backbone,
    num_tfs = nrow(backbone$module_info),
    num_targets = 500,
    num_hks = 500,
    verbose = FALSE
  )
print(Sys.time())
out <- generate_dataset(
  config,
  format = "dyno",
  make_plots = TRUE
)
print(Sys.time())

sce <- as_sce(out$model)
colData(sce)$pseudotime <- out$dataset$progressions$percentage ## use real time instead of pseudotime
saveRDS(sce, "~/scDesign3/data/sce/dyngen_linear_sce.rds")

#linear simple
backbone <- backbone_linear_simple()
config <-
  initialise_model(
    backbone = backbone,
    num_tfs = nrow(backbone$module_info),
    num_targets = 500,
    num_hks = 500,
    verbose = FALSE
  )
print(Sys.time())
out <- generate_dataset(
  config,
  format = "dyno",
  make_plots = TRUE
)
print(Sys.time())

sce <- as_sce(out$model)
colData(sce)$pseudotime <- out$dataset$progressions$percentage ## use real time instead of pseudotime
saveRDS(sce, "~/scDesign3/data/sce/dyngen_linear_simple_sce.rds")

#linear simple tf 10
backbone <- backbone_linear_simple()
config <-
  initialise_model(
    backbone = backbone,
    num_tfs = 10,
    num_targets = 500,
    num_hks = 500,
    verbose = FALSE
  )
print(Sys.time())
out <- generate_dataset(
  config,
  format = "dyno",
  make_plots = TRUE
)
print(Sys.time())

sce <- as_sce(out$model)
colData(sce)$pseudotime <- out$dataset$progressions$percentage ## use real time instead of pseudotime
saveRDS(sce, "~/scDesign3/data/sce/dyngen_linear_simple_tf10_sce.rds")


#linear tf10
backbone <- backbone_linear()
config <-
  initialise_model(
    backbone = backbone,
    num_tfs = 10,
    num_targets = 500,
    num_hks = 500,
    verbose = FALSE
  )
print(Sys.time())
out <- generate_dataset(
  config,
  format = "dyno",
  make_plots = TRUE
)
print(Sys.time())

sce <- as_sce(out$model)
colData(sce)$pseudotime <- out$dataset$progressions$percentage
saveRDS(sce, "~/scDesign3/data/sce/dyngen_linear_tf10_sce.rds")



#linear tf30
backbone <- backbone_linear()
config <-
  initialise_model(
    backbone = backbone,
    num_tfs = 10,
    num_targets = 500,
    num_hks = 500,
    verbose = FALSE
  )
print(Sys.time())
out <- generate_dataset(
  config,
  format = "dyno",
  make_plots = TRUE
)
print(Sys.time())

sce <- as_sce(out$model)
colData(sce)$pseudotime <- out$dataset$progressions$percentage
saveRDS(sce, "~/scDesign3/data/sce/dyngen_linear_tf30_sce.rds")
